﻿using System;
using Rackspace.Cloudfiles;

namespace Ucloudbiz.Storage
{
    /// <summary>
    /// KT_Connection object used to connect to the storage system through CF_Connection.
    /// </summary>
    public class KT_Connection : CF_Connection
    {
        private readonly Client _client;
        /// <summary>
        /// Initializes a new instance of the <see cref="Ucloudbiz.Storage.KT_Connection"/> class.
        /// </summary>
        /// <param name='creds'>
        /// An instance of a UserCredentials object
        /// </param>
        public KT_Connection (UserCredentials creds)
            : base (creds)
        {
            _client = new KT_Client();
        }
        /// <summary>
        /// Initializes a new instance of the <see cref="Ucloudbiz.Storage.KT_Connection"/> class.
        /// </summary>
        /// <param name='creds'>
        /// An instance of a UserCredentials object
        /// </param>
        /// <param name='client'>
        /// a HTTP client object 
        /// </param>
        public KT_Connection(UserCredentials creds, Client client)
            : base(creds, client)
        { }
    }
}
